/**
 *    Forms.java     20/06/2001  
 *    Un mini Paint 
 *
 *    Oscar Reyes Hevia / http://lucas.elo.utfsm.cl/~osrehe
 *   Por razones de tiempo los comentarios son en espaol
 */

import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.util.Vector;

/*
     <applet code=Forms.class width=400 height=400>
     </applet>

*/




public class Forms extends Applet{
    DrawPanel panel;
    DrawControls controls;

    public void init() {					/* init: primer mtodo ejecutado*/
	setLayout(new BorderLayout());
	panel = new DrawPanel();				/* Se crea un panel de dibujo*/
    controls = new DrawControls(panel);		/* Se crea un panel de controles*/
	add("Center", panel);
	add("South",controls);                  /* Se ubican espacialmente*/
    }

    public void destroy() {					/* Se ejecuta cuando el entorno determina que la applet tiene que ser*/
        remove(panel);						/* borrada de memoria, se liberan los recursos utilizados*/
        remove(controls);
    }

    public static void main(String args[]) {
	Frame f = new Frame("Forms");
	Forms forms= new Forms();
	forms.init();
	forms.start();							/* El mtodo start se ejecuta cada vez que se muestra en pantalla*/
											/* un documento HTML que contena un Applet, se ejecuta despues del init*/
	f.add("Center", forms);
	f.setSize(350, 300);					/* Tamao inicial*/
	f.show();
    }
    public String getAppletInfo() {
        return "A little Paint.";
    }
}
/****************************************************************************/

/* En la clase DrawPanel es donde se capturan los dibujos, registrando los 
   eventos realizados por el mouse*/
   
class DrawPanel extends Panel implements MouseListener, MouseMotionListener {
    public static final int LINES = 0;
    public static final int POINTS = 1;
    public static final int OVALS = 2;      /* Definicin de las variables */
    public static final int RECTS = 3;      /* que corresponden a los estados o modos*/
    public static final int FILL_OVALS = 4;
    public static final int FILL_RECTS = 5;
    public static final int ERASE = 6;
    
    int	   mode = LINES;					/* Modo inicial*/
    int    nmode;							/* */

    Vector lines = new Vector();			/* Vectores que almacenaran objetos de longuitud desconocida*/
    Vector colors = new Vector();
    
    
    int x1,y1;								/* Variables de coordenadas de ejes*/
    int x2,y2;
    int ox1,oy1;
    int ox2,oy2;
    int rx1,ry1;
    int rx2,ry2;
    int maxx,maxy;
    int minx,miny;
    
    int cont[]=new int[10000];				/* Contador nesesario para encontrar los objetos y redibujarlos*/
    int k=0;                                /* Variable de conteo*/
    
	
    public DrawPanel() {
	setBackground(Color.white);
	addMouseMotionListener(this);
	addMouseListener(this);
    }

    public void setDrawMode(int mode) {  	/* Se definen los modos, en uno de los cuales se escuentra el programa*/
	switch (mode) {							
	  case LINES:
	  case POINTS:
	  case OVALS:
	  case RECTS:
	  case FILL_OVALS:
	  case FILL_RECTS:
	  case ERASE:
	  
	    this.mode = mode;
	    break;
	  default:
	    throw new IllegalArgumentException();
	}
    }


    public void mouseDragged(MouseEvent e) { 	/* Esta instruccin o evento se ejecuta cuando el mouse */
        e.consume();							/* es movido con el botn pulsado*/
        switch (mode) {							/* Sentencia switch, dependiendo del modo, determina acciones*/
        	
            case ERASE:							/* ERASE. modo en el que se borran todos los objetos */
                 colors.removeAllElements();	/* anteriormente guardados*/
                 lines.removeAllElements();
                 break;

        	
            case RECTS:
                 rx2 = e.getX();
                 ry2 = e.getY();
                 break;						   	/* Se capturan las coordenadas en las cuales se encuetra el mouse*/
                								/* con el botn presionado, (dependiendo del modo)*/
            case FILL_RECTS:
        	     rx2 = e.getX();
                 ry2 = e.getY();
		         break;
                
        	case OVALS:
        	     ox2 = e.getX();
                 oy2 = e.getY();
                 break;
             
            case FILL_OVALS:
        	     ox2 = e.getX();
                 oy2 = e.getY();
                 break;   
                
            case LINES:
                 x2 = e.getX();
                 y2 = e.getY();
                 break;
            
            case POINTS:						/* Es necesario capturar todas las coordenadas de los puntos*/
                 default:						/* para su posterior reconstruccin*/
                 colors.addElement(getForeground());
                 lines.addElement(new Rectangle(x1, y1, e.getX(), e.getY()));
                 x1 = e.getX();
                 y1 = e.getY();
		         cont[k]=5;
		         k=k+1;
                 break;
               
        }
        repaint();
    }

    

    public void mousePressed(MouseEvent e) {	/* Esta instruccin se ejecuta cuando el mouse */
        e.consume();							/* es presionado */
        switch (mode) {
            case ERASE:
                 colors.removeAllElements();
                 lines.removeAllElements();
                 k=0;
                 break;

            case RECTS:
            	 rx1 = e.getX();
                 ry1 = e.getY();
                 break;							/* Se capturan las coordenadas iniciales o de origen de*/
            									/* de cada objeto o figura a grficar*/
            case FILL_RECTS:
            	 rx1 = e.getX();
                 ry1 = e.getY();
		         break;
            
            case OVALS:
            	 ox1 = e.getX();
                 oy1 = e.getY();
                 break;
                
            case FILL_OVALS:
                 ox1 = e.getX();
                 oy1 = e.getY();
                 break;
         
            case LINES:
                 x1 = e.getX();
                 y1 = e.getY();
                 break;
                
            case POINTS:
            default:
                 colors.addElement(getForeground());
                 lines.addElement(new Rectangle(e.getX(), e.getY(), -1, -1));
                 x1 = e.getX();
                 y1 = e.getY();
		         cont[k]=5;
		         k=k+1;
                 repaint();
                 break;
        }
    }

    public void mouseReleased(MouseEvent e) {	/* Esta instruccin se ejecuta cuando el botn delmouse */
        e.consume();							/* es levantado */
        switch (mode) {

            case ERASE:
                 colors.removeAllElements();	/* Es necesario capturar las coordenadas finales de*/
                 lines.removeAllElements();		/* de cada objeto dibujado, para pasarlas como parmetro a "paint"*/
                 break;
        	
            case RECTS:
                 colors.addElement(getForeground());
                 lines.addElement(new Rectangle(minx,miny,maxx - minx, maxy - miny));
                 cont[k]=1;
		         k=k+1;							/* Las coordenadas min y max, corresponden a las coordenadas finales del objeto. */
		         rx2 = -1;						/* Y son definidas para lograr que para que el objeto se dibuje correctamente en */
		         break;							/* cualquier cuadrante del plano*/
        										
            case FILL_RECTS:
                 colors.addElement(getForeground());
                 lines.addElement(new Rectangle(minx,miny,maxx - minx, maxy - miny));
	             cont[k]=2;
		         k=k+1;
                 rx2 = -1; 						/*  rx2 = -1. Ajusta el color de los dibujos recin trminados */
                 break;
        	
            case OVALS:
                 colors.addElement(getForeground());
                 lines.addElement(new Rectangle(minx,miny,maxx - minx, maxy - miny));
                 cont[k]=3;
		         k=k+1;
		         ox2 = -1;
                 break;
            
            case FILL_OVALS:
                 colors.addElement(getForeground());
                 lines.addElement(new Rectangle(minx,miny,maxx - minx, maxy - miny));
                 cont[k]=4;
		         k=k+1;
		         ox2 = -1;
                 break;   
                
            case LINES:
                 colors.addElement(getForeground());
                 lines.addElement(new Rectangle(x1, y1, e.getX(), e.getY()));
                 cont[k]=5;
		         k=k+1;
		         x2 = -1;
                 break;
            
            case POINTS:
                 default:
                 break;
        }
        repaint();
    }

    public void mouseEntered(MouseEvent e) {
    }
													/* Eventos del mouse no ocupados*/
    public void mouseExited(MouseEvent e) {
    }
    
    public void mouseMoved(MouseEvent e) {
    }
    
    public void mouseClicked(MouseEvent e) {		/* Se ejecuta cuando hacemos un click con el mouse*/
      switch (mode) {						/* Se borran todos los objetos almacenados*/
            case ERASE:
                 colors.removeAllElements();
                 lines.removeAllElements();
	             k=0;								/* La variable k, ndice que contiene el modo de un objeto ya dibujado*/
                 break;								/* k, se setea en cero, para ser consencuente con el borrado*/ 
              }

    }
/****************************************************************************/
    
/* mtodo paint encargado de dibujar temporalmente los dibujos, y de mostrar 
   persistentemente los dibujos hechos una vez que ya se solt el mouse*/
    
    public void paint(Graphics g) {

            
            /** dibujos persistentes **/   
    
   
    int nfr = lines.size();							/* Tamao del vector que contiene todos los objetos creados*/
	

         //System.out.println("valor=" + k);
	
	for (int j=0; j < nfr; j++) {
	    Rectangle p = (Rectangle)lines.elementAt(j);/* Se recuperan las coordenadas del objeto j*/
        nmode= cont[j];								/* Se determina el tipo de cada objeto */	
	   
	    //System.out.println("k=" + k);	
	
	switch(nmode) {

           case 1:
            	g.setColor((Color)colors.elementAt(j));
	            if (p.width != -1) {
		        g.drawRect(p.x, p.y, p.width, p.height);
	            } else {
		        g.drawRect(p.x, p.y, p.x, p.y);
	     	    }
                break;

           case 2:
            	g.setColor((Color)colors.elementAt(j));
	            if (p.width != -1) {
		        g.fillRect(p.x, p.y, p.width, p.height);
	            } else {
		        g.fillRect(p.x, p.y, p.x, p.y);
	            }
                break;

	       case 3:
            	g.setColor((Color)colors.elementAt(j));
	            if (p.width != -1) {
		        g.drawOval(p.x, p.y, p.width, p.height);
	            } else {
		        g.drawOval(p.x, p.y, p.x, p.y);
	            }
                break;

          case 4:
            	g.setColor((Color)colors.elementAt(j));
     	        if (p.width != -1) {
		        g.fillOval(p.x, p.y, p.width, p.height);
	            } else {
		        g.fillOval(p.x, p.y, p.x, p.y);
	            }
                break;

	     case 5:
            	g.setColor((Color)colors.elementAt(j));
	            if (p.width != -1) {
		        g.drawLine(p.x, p.y, p.width, p.height);
	            } else {
		        g.drawLine(p.x, p.y, p.x, p.y);
	            }
                break;


	}
      }

                 /** dibujos temporales **/

	if (mode == LINES) {
	   g.setColor(getForeground());
	   if (x2 != -1) {
           g.drawLine(x1, y1, x2, y2);
	   }
	}
        	
	else if (mode == RECTS) {
	    g.setColor(getForeground());
	    if (rx2 != -1) {
	        if (rx1>rx2){			
	        	maxx=rx1;
	        	minx=rx2;
	        	}
	        else{					/* Se determinan las coordenadas temporales de cada objeto*/	
	            maxx=rx2;			        /* Para el correcto despliegue en el plano.*/
	        	minx=rx1;			/* Se quiere principalmente encontrar las mnimas coordenadas x e y*/
	            }					/* que representen el origen del dibujo. Luego con las nuevas*/
							/* coordenadas encontradas se determina el ancho y alto de cada figura*/
	         if (ry1>ry2){
	        	maxy=ry1;
	        	miny=ry2;
	        	}
	         else{	
	            maxy=ry2;
	        	miny=ry1;
	            }
	         g.drawRect(minx,miny,maxx - minx, maxy - miny);
           }
        }
	
	else if (mode == FILL_RECTS) {
	    g.setColor(getForeground());
	    if (rx2 != -1) {
	        if (rx1>rx2){
	        	maxx=rx1;
	        	minx=rx2;
	        	}
	        else{	
	            maxx=rx2;
	        	minx=rx1;
	            }
	
	         if (ry1>ry2){
	        	maxy=ry1;
	        	miny=ry2;
	        	}
	         else{	
	            maxy=ry2;
	            miny=ry1;
	            }
	            	    	
	         g.fillRect(minx,miny,maxx - minx, maxy - miny);
	       }
	    }

	else if (mode == OVALS) {
            g.setColor(getForeground());
            if (ox2 != -1) {
	        if (ox1>ox2){
	        	maxx=ox1;
	        	minx=ox2;
	        	}
	        else{	
	            maxx=ox2;
	        	minx=ox1;
	            }
	
	         if (oy1>oy2){
	        	maxy=oy1;
	        	miny=oy2;
	        	}
	         else{	
	            maxy=oy2;
	        	miny=oy1;
	            }
	          	    	
	         g.drawOval(minx,miny,maxx - minx, maxy - miny);
	       }
	    }
	
	else if (mode == FILL_OVALS) {
	    g.setColor(getForeground());
	    if (ox2 != -1) {
	        if (ox1>ox2){
	        	maxx=ox1;
	        	minx=ox2;
	        	}
	        else{	
	            maxx=ox2;
	        	minx=ox1;
	            }
	
	         if (oy1>oy2){
	        	maxy=oy1;
	        	miny=oy2;
	        	}
	         else{	
	            maxy=oy2;
	        	miny=oy1;
	            }
	            	    	
	         g.fillOval(minx,miny,maxx - minx, maxy - miny);
	       }
	    }

      }
   }

/****************************************************************************/

/* La clase DrawControls se define para desplegar en pantalla los menus */

 class DrawControls extends Panel implements ItemListener {
    DrawPanel target;

    public DrawControls(DrawPanel target) {
	this.target = target;
	setLayout(new FlowLayout());
	setBackground(Color.lightGray);
	target.setForeground(Color.red);
	
	CheckboxGroup group = new CheckboxGroup();
	Checkbox b;
	add(b = new Checkbox(null, group, false)); /* Definicin de colores del panel de control*/
	b.addItemListener(this);
	b.setForeground(Color.red);     
	add(b = new Checkbox(null, group, false));
	b.addItemListener(this);
	b.setForeground(Color.green);
	add(b = new Checkbox(null, group, false));
	b.addItemListener(this);
	b.setForeground(Color.yellow);
	add(b = new Checkbox(null, group, false));
	b.addItemListener(this);
	b.setForeground(Color.blue);
	add(b = new Checkbox(null, group, false));
	b.addItemListener(this);
	b.setForeground(Color.cyan);
	add(b = new Checkbox(null, group, false));
	b.addItemListener(this);
	b.setForeground(Color.pink);
	add(b = new Checkbox(null, group, false));
	b.addItemListener(this);
	b.setForeground(Color.orange);
	add(b = new Checkbox(null, group, true));
	b.addItemListener(this);
	b.setForeground(Color.black);
	target.setForeground(b.getForeground());
	
	Choice shapes = new Choice();			 /* Se crea el menu desplegable de modos de dibujo*/
	shapes.addItemListener(this);
	shapes.addItem("Lines");
	shapes.addItem("Points");
	shapes.addItem("Ovals");
	shapes.addItem("Rectangules");
	shapes.addItem("Fill_Ovals");
	shapes.addItem("Fill_Rectangules");
    shapes.addItem("*   ERASE   *");
	shapes.setBackground(Color.lightGray);
	add(shapes);
    }

    public void paint(Graphics g) {			/* Se crea el panel de colores*/
	Rectangle r = getBounds();
	g.setColor(Color.lightGray);
	g.draw3DRect(0, 0, r.width, r.height, false);

        int n = getComponentCount();
        for(int i=0; i<n; i++) {
            Component comp = getComponent(i);
            if (comp instanceof Checkbox) {
                Point loc = comp.getLocation();
                Dimension d = comp.getSize();
                g.setColor(comp.getForeground());
                g.drawRect(loc.x-1, loc.y-1, d.width+1, d.height+1);
            }
        }
    }

  public void itemStateChanged(ItemEvent e) {		/* Dependiendo del modo de dibujo seleccionado se determina*/
    if (e.getSource() instanceof Checkbox) {		/* el modo real de dibujo*/
      target.setForeground(((Component)e.getSource()).getForeground());
    } 
    else if (e.getSource() instanceof Choice) {
      String choice = (String) e.getItem();
      
         if (choice.equals("Lines")){
	     target.setDrawMode(DrawPanel.LINES);
         } 
         else if (choice.equals("Points")){
	     target.setDrawMode(DrawPanel.POINTS);
         }
         else if (choice.equals("Ovals")){
	     target.setDrawMode(DrawPanel.OVALS);
         }
         else if (choice.equals("Rectangules")){
	     target.setDrawMode(DrawPanel.RECTS);
         }
         else if (choice.equals("Fill_Ovals")){
	     target.setDrawMode(DrawPanel.FILL_OVALS);
         }
         else if  (choice.equals("Fill_Rectangules")){
	     target.setDrawMode(DrawPanel.FILL_RECTS);
         }
	else if  (choice.equals("*   ERASE   *")){
	     target.setDrawMode(DrawPanel.ERASE);
         }
        
   }
  }
 }




